# LDS.s  Load Delay Slot example

       .data		# Data declaration section
title: .asciiz  "\nLoad Delay Slot test\n"
strt1: .asciiz  "\nOld memory = "
strt2: .asciiz  "\tNew memory = "
memory: .word    100        # Initialize memory (100)
new:   .asciiz  "\nThey are the same so no delay"
old:   .asciiz  "\nThey are different which shows the delay"

       .text            # Start of code section
main:			      
       li       $v0,4       # print_str
       la       $a0,title 
       syscall
       la       $s0,memory  # Initialize memory ptr
       li       $t0,0       # Initialize register (0)
       la       $a0,strt1
       li       $v0,4       # print_str
       syscall
## Test the Load Delay Slot Here
       lw       $t0,0($s0)  # contents of memory (100)
       move     $s1,$t0     # **LDS** old value (0?)
       move     $s2,$t0     # new value by now (100)
## Now see the results
       move     $a0,$s1     # old value
       li       $v0,1       # print_int
       syscall
       la       $a0,strt2
       li       $v0,4       # print_str
       syscall
       move     $a0,$s2     # new value
       li       $v0,1       # print_int
       syscall
## Explain result
       beq      $s1,$s2,no
       la       $a0,old     # yes
       li       $v0,4
       syscall
       b        exit
no:    la       $a0,new
       li       $v0, 4
       syscall
exit:  li       $v0,10      # exits program
       syscall
	
# END OF LDS.s
