# calculate-f.s
#
# $f2 = first float
# $f4 = second float
# $a0 = operation (1=Add,2=Subtract,3=Multiply,4=Divide)
# NO error checking 
# 
	 .data
prompt1: .asciiz  "\nInput a real (float): "
prompt2: .asciiz  "\nInput another real (float): "
help:    .asciiz  "\n 1=ADD, 2=SUB, 3=MUL, 4=DIV, 5=EXIT: "
       .align 4
JumpTable:	
       .word  ADD,SUB,MUL,DIV # SPIM figures out where
# 
	 .text
###########################################################
calculate:			    # <= Entry point
	 sub	  $sp,$sp,8	    # \  Push registers
	 sw	  $t0,0($sp)    #  > which are changed
	 sw	  $t1,4($sp)    # /  onto the stack
	 la	  $t0,JumpTable # Get address of JumpTable
	 sub	  $t1,$a0,1	    # Zero-based addressing
	 sll	  $t1,$t1,2	    # Multiply by 4 (bytes)
	 add	  $t0,$t0,$t1   # Place in table
	 lw	  $t0,0($t0)    # Actual address
	 jr	  $t0
# switch labels
ADD:   add.s  $f12,$f2,$f4  # Do the addition
	 j	  DONE
SUB:   sub.s  $f12,$f2,$f4  # Do the subtraction
	 j 	  DONE
MUL:   mul.s  $f12,$f2,$f4  # Do the multiplication
	 j	  DONE
DIV:   div.s  $f12,$f2,$f4  # Do the division
	 j	  DONE          # (see below)
# finished; return
DONE:  lw	  $t1,4($sp)    # \  Pop registers
	 lw	  $t0,0($sp)    #  > which were changed
	 add	  $sp,$sp,8	    # /  off the stack
	 jr	  $ra		    # return
############################################################
main:				    # <= main entry point
	 li	  $v0,4
	 la	  $a0,prompt1
	 syscall
	 li	  $v0,6         # read_float
	 syscall
	 mov.s  $f2,$f0       # 1st in $f2
	 li	  $v0,4
	 la	  $a0,prompt2
	 syscall
	 li	  $v0,6         # read_float
	 syscall
	 mov.s  $f4,$f0       # 2nd in $f4
# calculator calls
loop:	 li	  $v0,4
	 la	  $a0,help
	 syscall
	 li	  $v0,5
	 syscall
	 beq	  $v0,5,exit
	 move	  $a0,$v0       # which operation in $a0
	 jal	  calculate
	 li	  $v0,2         # answer is in $f12
	 syscall
	 j	  loop
exit:  li	  $v0,10
	 syscall


