# multiply.s 
# integers without using the multiplication
# instruction but repeated addition instead
######  REGISTER USE:  ##################
#
##    $s1   first integer - constant (or negated)
##	$s2   second integer - decreasing (made positive)
##	$s4   current answer
#	
######################################### 
	  .data
promp1: .asciiz "Input first integer value: "
promp2: .asciiz "\nInput second integer value: "
answer: .asciiz "\nThe product is "
newln:  .asciiz "\n"
#########################################





	  .text
	  .globl main	
main:
## Get input
# prompt for first value   
     	  li      $v0, 4        # system call for print_str   
     	  la      $a0, promp1   # address of string to print    
    	  syscall
# read and echo first value
	  li	    $v0, 5	      # system call for read_integer
	  syscall		      # x in $v0
	  move    $s1, $v0      # put in register
        li      $v0, 1        # system call for print_int
        move    $a0, $s1      # echo
	  syscall
# prompt for second value   
     	  li      $v0, 4        # system call for print_str    
    	  la      $a0, promp2   # address of string to print    
    	  syscall
# read and echo second value	
	  li	    $v0, 5	      # system call for read_integer
	  syscall		      # y in $v0
	  move    $s2, $v0      # put in register as constant
        li      $v0, 1        # system call for print_int
        move    $a0, $s2      # echo
	  syscall
	  bltz    $s2, twoneg   # if 2nd negative, change both
##################################
# initialize
init:   li      $s4, 0        # inital value
##### Loop with test at beginning (while)
loop:   blez    $s2, endloop  # end of loop 
	  add	    $s4, $s4, $s1
	  sub	    $s2, $s2, 1
	  j	    loop          # <= Breakpoint
endloop:
##################################
##### Print answer
        li      $v0, 4        # system call for print_str
        la      $a0, answer
	  syscall
        li      $v0, 1        # system call for print_int
        move    $a0, $s4
	  syscall
#### Exit  
exit:   li      $v0, 10          
     	  syscall               # Return control to the OS 
#### Second argument negative - negate both
twoneg: neg     $s2, $s2
        neg     $s1, $s1
	  j	    init
####

