# reverse.s
# Input: Any string
# Output: The reverse of that string
######################################
         .data
prompt:  .asciiz   "Input any string: "
echo:    .asciiz   "\nThe reverse of \n\t"
is:      .asciiz   "is \n\t"
buffer:  .space    78
         .word     0            #Null for reversed string
# 
         .text
# Input string with prompt and echo
main:    li        $v0,4	  #string print function
         la        $a0,prompt   #prompt string
         syscall
         li        $v0,8        #string read function
         la        $a0,buffer   #where to put it
         li        $a1,78       #how many characters max
         syscall
         li        $v0,4        #string print function
         la        $a0,echo     #echo string
         syscall
         li        $v0,4        #string print function
         la        $a0,buffer   #buffer (including LF)
         syscall
         li        $v0,4        #string print function
         la        $a0,is       #"is"
         syscall  
#start actual processing
         la        $s1,buffer   #get address of start of buffer
         addi      $s1,77       #point to end of buffer
#find end of actual string
look:    lb        $t1,0($s1)   #loading a byte
         bnez      $t1,found    #finally not Null
         sub       $s1,1        #back up 1 byte
         j         look         #keep looking
#reverse the string in place
found:   sub       $s1,1        #ignore LF (0x0a)
         la        $s2,buffer   #point to beginning of string
#here is the loop for reversing (s1 r end; s2 r beginning)	
rev:     bgt       $s2,$s1,done #middle found
         lb        $t1,0($s1)   #\ 
         lb        $t2,0($s2)   #  interchange
         sb        $t1,0($s2)   #  the bytes
         sb        $t2,0($s1)   #/ 
         add       $s2,1        #update the pointer
         sub       $s1,1        #update the pointer
         j         rev          #do it again
#now print result
done:    li        $v0,4        #string print function
         la        $a0,buffer   #reversed string with LF and Null
         syscall
         li        $v0,10       #standard exit
         syscall                #return to OS
