# BDS.s  Branch Delay Slot example

       .data		# Data declaration section
title: .asciiz  "\nBranch Delay Slot test\n"
strt1: .asciiz  "\n$t1 = "
strt2: .asciiz  "\t$t2 = "

       .text

main:			# Start of code section
       li       $v0,4       # print_str
       la       $a0,title 
       syscall

       li       $t1,0       # Initialize
       li       $t2,0       # Initialize
       li       $t3,10      # Limit test

loop: 
       bge      $t1,$t3,exit
       nop                  # BDS
       la       $a0,strt1
       li       $v0,4       # print_str
       syscall
       move     $a0,$t1 
       li       $v0,1       # print_int
       syscall
       la       $a0,strt2
       li       $v0,4       # print_str
       syscall
       move     $a0,$t2 
       li       $v0,1       # print_int
       syscall

       add      $t1,$t1,1   # increment $t1
       b        loop        # Next is BDS
       add      $t2,$t2,1   # increment $t2 ?

exit:
       li       $v0,10      # exits program
       syscall
	
# END OF BDS.s
