# Clock.s         # Suggested by Dr. Herman Harrison  

        .data     # Data declaration section
title:  .ascii    "\nTic/Toc Timing\n"
        .asciiz   "<Control-C> to stop\n"
Tic:    .asciiz   "\nTic"
Toc:    .asciiz   "\nToc"
pause:  .word     100000      # Adjust as needed

        .text

main:             # Start of code section
        li        $v0,4
        la        $a0,title
        syscall
# 
loop:
        lw        $t0,pause  
loop1:  sub       $t0,$t0,1   # Count down
        bgez      $t0,loop1   # Test
        la        $a0,Tic     # Print
        li        $v0,4       # "Tic"
        syscall
        lw        $t0,pause  
loop2:  sub       $t0,$t0,1   # Count down 
        bgez      $t0,loop2   # Test
        la        $a0,Toc     # Print
        li        $v0,4       # "Toc"
        syscall
        b         loop        # Until <Control-C>

# END OF Clock.s
