# characterio.s
# 
# Demonstrates character I/O functions 11 and 12
# 
	  .data			# Data declaration section
buffer: .space	4		# Room for one word
prompt: .asciiz	"Proceed? (y/n): "
yes:    .asciiz	"\nYES!\n"
no:     .asciiz   "\nNO!!"
echo:   .asciiz   "\nYou entered: "
y:	  .word	0x79		# Lower case "y" in low 8 bits
Y:      .word	0x59		# Upper case "Y" in low 8 bits
	  .text
main:					# Start of code section
	  li		$v0,4	
	  la		$a0,prompt
	  syscall			# Print prompt
	  li	      $v0,12
	  syscall			# Read 1 character (without LF)
	  move	$s0,$v0	# Save it 
	  lw		$t0,y
	  lw	      $t1,Y
	  beq	      $t0,$v0,OK	# Test for lc "y"
	  beq	      $t1,$v0,OK	# Test for uc "Y"
# Anything but 'y' or "Y"
	  li		$v0,4
	  la		$a0,no
	  syscall			# Print "NO!!" message
	  la	      $a0,echo
	  syscall
	  li		$v0,11
	  move	$a0,$s0
	  syscall			# Print the actual character
	  j		exit
# It was 'y' or "Y"
OK:	  li		$v0,4
	  la		$a0,yes
	  syscall			# Print "YES!" message
exit:
	  li $v0, 10		# exits program
	  syscall
	

	


# END OF PROGRAM
