# forLoopTest.s
# Driver program testing a "for" loop
# 
       .data
       .word  0xffffffff
array: .space 100
       .word  0xeeeeeeee
# 
       .text
main:  la     $t0, array
       li     $t1, 25
################################################################
# assume: $t0 contains the address of the 100 bytes 
# (maybe after an la $t0,array instruction)
# assume: $t1 contains the integer 25 
# (the number of words desired)
# assume: $s0 contains the counter i; first initialize it to zero
       li   $s0,0	  # or move $s0,$0 or some other initialization
loop:  beq  $s0,$t1,done  # when i == 25 we are finished, branch 
       sw   $s0,0($t0) # array[i] = i;
       add  $t0,$t0,4  # each integer is 4 bytes long 
       add  $s0,$s0,1  # increment the count by 1
       j    loop       # go back and do the loop test again
done:                  # ready for the next instruction; however,
# $t0 no longer contains the address of the 100 bytes = 25 words!
################################################################
       li   $v0, 10
       syscall
